/************************************************************************\
*									 *
*									 *
*    *****			*****					 *
*      *****		      *****					 *
*	 *****		    *****					 *
*	   *****	  *****						 *
*	     *****	*****		The Firmware.			 *
*	       *****  *****		The Net.			 *
*	     *****	*****		The Boxware.			 *
*	   *****	  *****		Software for Ham Radio.		 *
*	 *****		    *****	Portable. Compatible.		 *
*      *****		      *****	General Public Licensed.	 *
*    *****			*****	By NORD><LINK.			 *
*									 *
\************************************************************************/


/*** externe Definitionen fuer Level 3					   ***/
extern	char	 rxfhdr[];	/* empfangener Frameheader		     */
extern	char	 txfhdr[];	/* zu sendender Frameheader		     */
extern	unsigned nmbfre;	/* Zahl der freien Buffer		     */
extern	LNKBLK	 lnktbl[];	/* Level2 Kontrollbloecke		     */
extern	LNKBLK	 *lnkpoi;	/* Pointer in l2lnk			     */
extern	LHEAD	 l4rxfl;	/* fuer Level4 eingegangene Frames	     */
extern	unsigned ininat;	/* no activity timeout			     */
#ifndef BOXWARE
extern	unsigned Flags;		/* Parameter 30				     */
extern	char	 rxfprt;	/* Port, ueber den das Frame kam	     */
#endif

extern  MBHEAD  *allocb();	/* Buffer besorgen                           */


/*** nicht-integer zurueckgebende Funktionen des Level 3		     */
MBHEAD	 *brobuf();
BOOLEAN	 chgnod();
unsigned srtrou();
BOOLEAN	 isgood();
NBRTYP	 *updnbr();
NBRTYP	 *getnei();
BOOLEAN  isidnt();
BOOLEAN  isrout();
BOOLEAN  isneig();
BOOLEAN  ge6chr();
BOOLEAN  iscall();
#ifdef SPLCHK
BOOLEAN  splchk();
#endif

/*** Strings fuer Level 3						     */
extern	char	 myid[];	/* Call des TNC				     */
extern	char	 alias[];	/* Ident des TNC			     */
extern	char	brodes[];			/* Ziel (Rundsprueche)       */
#ifdef BOXWARE
extern	char	brodil[];			/* Digiliste (Rundsprueche)  */
#else						/* Call im Standardformat    */
extern	char	 nulstr[];
extern	char	 alias0[];
extern	char	 alias1[];
#define brodil nulstr				/* Listenende = 0            */
#endif
extern	char	hidide[];		/* Ident fuer versteckte Nodes	     */
extern	char	nulide[];		/* leerer Ident o. leeres Call	     */
/*extern	char	nulssid[];*/
extern	char	l3rttc[];		/* Call fuer L3RTT-Frames	     */


extern	unsigned maxdes;	/* Laenge der Zielliste maximal		     */
extern	unsigned worqua;	/* minimal Qualitaet fuer Autoupdate	     */
extern	unsigned ch0qua;	/* HDLC Kanal Qualitaet			     */
extern	unsigned obcini;	/* Anfangswert fuer Knoten Lebensdauer	     */
extern	unsigned broint;	/* Rundspruchintervall			     */
extern	unsigned timliv;	/* Anfangswert Paketlebensdauer		     */
extern	unsigned myqua;		/* eigene Qualitaet fuer Rundspruch	     */
#ifndef BOXWARE
extern	unsigned ch1qua;	/* RS232 Kanal Qualitaet		     */
extern	unsigned obcbro;	/* min. Restlebensdauer fuer Rundspruch	     */
#endif
extern	unsigned numdes;		/* aktuelle Laenge des Zielliste	     */
extern	unsigned brotim;		/* Uhr fuer Rundsprueche		     */
extern	unsigned qualty;		/* aktuelle Qualitaet			     */

extern	LHEAD	 destil;		/* Ziele Liste				     */
extern	LHEAD	 neigbl;		/* Nachbarn Liste			     */

extern	LHEAD	 l3rxfl;		/* Level3 empfangene Frames		     */
extern	LHEAD	 l3txl;			/* Level3 zu senddende Frames		     */

extern	NODTYP	 *despoi;		/* Pointer auf aktuellen Knoten		     */
extern	NBRTYP	 *nbrpoi;		/* Pointer auf aktuellen Nachbarn	     */

extern	WEGTYP	 routmp[];		/* Arbeitsspeicher fuer Wege sortieren	     */
extern	WEGTYP	 rouwrk;		/* Arbeitsspeicher fuer Wege sortieren	     */

