/**************************************************************************\
*                                                                          *
*                                                                          *
*    *****                      *****                                      *
*      *****                  *****                                        *
*        *****              *****                                          *
*          *****          *****                                            *
*            *****      *****                                              *
*              *****  *****                                                *
*            *****      *****                                              *
*          *****          *****          The Firmware.                     *
*        *****              *****        Portable. Compatible.             *
*      *****                  *****      Public Domain.                    *
*    *****                      *****    By NORD><LINK.                    *
*                                                                          *
*                                                                          *
*                                                                          *
*    TFEXT.H   -   Externals fuer TheFirmware                              *
*                  (globale Variable und nicht-int-Funktionen)             *
*                                                                          *
*    angelegt:      DC4OX                                                  *
*                                                                          *
*    modifiziert:   DL8ZAW, versch. Referenzen auf neue Variablen          *
*                   Erlaeuterung dazu: siehe C-Module                      *
*                                                                          *
\**************************************************************************/

/*                                                           Funktionen   */
/**************************************************************************/

extern char       *minmem();                      /* L1...                */
extern char       *maxmem();

extern BOOLEAN     digipt();                      /* L2...                */
extern BOOLEAN     tol3sw();
extern BOOLEAN     srxdNR();
extern BOOLEAN     isnxti();
extern BOOLEAN     splcpy();
extern unsigned    setNR();
extern MBHEAD     *cpyfb();
extern BOOLEAN     takfhd();
extern BOOLEAN     getfid();
extern MBHEAD     *makfhd();
extern BOOLEAN     istome();
extern BOOLEAN     cmpcal();
extern BOOLEAN     cmpidl();
extern BOOLEAN     cmpid();
extern BOOLEAN     l1put();
extern unsigned    l1get();
extern LEHEAD     *allocb();
extern LEHEAD     *unlink();
extern LEHEAD     *relink();

extern BOOLEAN     fmlink();                      /* TF...                */
extern unsigned    bgetp();

#ifdef DRSI
extern unsigned    bgetport();
extern char        bgetprt();
#endif

extern BOOLEAN     ismonf();
extern unsigned    mbcnt();
extern MBHEAD     *selmb();
extern BOOLEAN     invial();
extern BOOLEAN     nxtnos();
extern unsigned    nbrprt();
extern BOOLEAN     isrout();
extern BOOLEAN     iswarm();

/*                                                             Variable   */
/**************************************************************************/

extern char        defESC;                        /* TFL1...              */
extern char        defIp[];
extern char        defID[];
extern char        defYp;
extern char        defMp;
extern char        defRp;
extern char        defPp;
extern char        defWp;
extern char        defTp;
extern char        defZp;
extern char        defXp;
extern char        defAp;
extern char        defEp;
extern char        defVp;
extern char        defOp;
extern char        defNp;
extern char        defVCp;
extern char        defCp;
extern char        defDp;
extern char        defM7p;
extern char        defUIp;
extern char        defxSp;
extern char        defxFp;
extern char        defHp;
extern unsigned    defHmp;
extern unsigned    defT2p;
extern unsigned    defT2d;
extern unsigned    defT3p;
extern unsigned    defTAp;
extern unsigned    defFp;
extern char        defIPp;
extern char        defA1p;
extern char        defA2p;
extern char        defA3p;
extern unsigned    defDAp;

extern unsigned    p1end;
extern unsigned    p2strt;

#ifdef DRSI
extern BOOLEAN     drmsg;
extern BOOLEAN     dxmsg;
#endif

extern char        myid[];                        /* L2...                */
extern char        alias[];
extern unsigned    linknmbr;
extern char        nmblks;
extern char        Ypar;
extern char        Vpar;
extern char        rxfhdr[];
extern char        rxfctl;
extern char        rxfPF;
extern char        rxfV2;
extern char        rxfCR;
extern char        rxfprt;
extern char        txfhdr[];
extern char        txfctl;
extern char        txfPF;
extern char        txfV2;
extern char        txfCR;
extern char        txfprt;
extern unsigned    Fpar;
extern unsigned    Ipar;
extern unsigned    Opar[];
extern unsigned    Npar;
extern unsigned    T2par[];
extern unsigned    T2dama[];
extern unsigned    T3par;
extern unsigned    A1par;
extern unsigned    A2par;
extern unsigned    A3par;
extern unsigned    DApar[];
extern char        M7par;
extern char        UIpar;
extern unsigned    damati[];
extern char        damaok[];
extern unsigned    Rpar;
extern unsigned    nmbfre;
extern LHEAD       freel;
extern LHEAD       rxfl;
extern LHEAD       stfl;
extern LHEAD       trfl;
extern LHEAD       txl2fl[];
extern MBHEAD     *rxfhd[];
extern MBHEAD     *txfhd[];
extern LNKBLK     *lnktbl;
extern LNKBLK     *lnkpoi;

#ifdef DRSI
extern unsigned    txfrms[];
extern unsigned    txifrms[];
extern unsigned    txiacks[];
extern unsigned    rxfrms[];
extern unsigned    rxifrms[];
extern unsigned    rxieff[];
#endif

extern LHEAD       monfl;                         /* TF...                */

#ifdef DRSI
extern LNKENTRY    lnklst[];
extern char        ch0prt;
#endif

extern char        ch0id[];
extern char        ch0via[];
extern char        hinbuf[];
extern char       *inbufp;
extern char        Apar;
extern char        Epar;
extern char        actch;
extern char        Xpar[];
extern char        Zpar;
extern char        Cpar[];
extern char        Dpar[];
extern char        Tpar[];
extern char        Ppar[];
extern char        Palt[];
extern char        Wpar[];
extern char        Upar;
extern char        Utxt[];
extern char        Mpar;
extern char        mftsel;
extern char        mftidl[];
extern char        ishmod;
extern char        hmstat;
extern char        hmch;
extern char        hmcmd;
extern char        hmlen;
extern unsigned    incnt;
extern unsigned    isctlr;
extern unsigned    ticks;
extern unsigned    oldtic;
extern unsigned    Utcnt;
extern unsigned    TApar[];
extern unsigned    VCpar;
extern unsigned    magicn;
extern MBHEAD     *mifmbp;
extern LHEAD       l3rxfl;
extern LHEAD       statml;
extern LHEAD       smonfl;
extern LHEAD       chnlml[];
extern LHEAD       heardl;
extern unsigned    numhrd;
extern unsigned    maxhrd;

#ifdef TFPC
extern BOOLEAN     stampok;
#endif

extern unsigned    sec100;
extern TIMEBL      time;
extern char        eudate;
extern char        stamp;
extern char        xFpar;
extern char        heard;
extern HEARDB     *hrdmbp;

extern char        stmem[];
extern char        stack;
extern unsigned    fremem;

extern char        cqid[];
extern unsigned    ininat;
extern unsigned    conctl;
extern char       *l2msgs[];
extern VOID      (*cmdtab[])();

extern unsigned    end;                           /* CRUNTIME             */

/* Ende von TFEXT.H */
